# classicthesis package
# Matthew Bertucci 2025/02/03 for v4.8

#include:ifthen
#include:kvoptions
#include:ifpdf
#include:ifxetex
#include:ifluatex
#include:xcolor
#include:mathpazo
#include:beramono
#include:microtype
#include:typearea
#include:mparhack
#include:booktabs
#include:textcase
#include:scrlayer-scrpage
#include:titlesec
#include:tocloft
#include:footmisc
#include:scrtime
#include:caption
#include:hyperref

#ifOption:drafting
#include:prelim2e
#endif
#ifOption:drafting=true
#include:prelim2e
#endif

#ifOption:style=arsclassica
#include:classicthesis-arsclassica
#endif

#keyvals:\usepackage/classicthesis#c
drafting#true,false
style=#classicthesis,arsclassica,linedheaders,plain
palatino#true,false
eulerchapternumbers#true,false
beramono#true,false
eulermath#true,false
tocaligned
dottedtoc
manychapters
floatperchapter
a4paper
a5paper
b5paper
letterpaper
#endkeyvals

CTsemi#B
CTcitation#B
CTurl#B
CTtitle#B
CTlink#B
halfgray#B
webgreen#B
webbrown#B

\begin{aenumerate}#S
\end{aenumerate}#S
\ctparttext{text}#S
\spacedallcaps{text}#S
\spacedlowsmallcaps{text}#S
\spacedlowsmallcapsstyle#S
\classicthesis#S
\chapterNumber{text}#S
\beforebibskip#S
\figurelabelwidth#S
\finalVersionString#S
\listingslabelwidth#S
\myVersion#S
\newchnumberwidth#S
\newnumberwidth#S
\oldmarginpar{right%text}#S
\oldmarginpar[left]{right%text}#S
\tablelabelwidth#S
\tocEntry{text}#S
\deactivateaddvspace#S

# deprecated
\myChapter#S
\myPart#S
\graffito#S

# from dvipsnames option of xcolor
Apricot#B
Aquamarine#B
Bittersweet#B
Black#B
Blue#B
BlueGreen#B
BlueViolet#B
BrickRed#B
Brown#B
BurntOrange#B
CadetBlue#B
CarnationPink#B
Cerulean#B
CornflowerBlue#B
Cyan#B
Dandelion#B
DarkOrchid#B
Emerald#B
ForestGreen#B
Fuchsia#B
Goldenrod#B
Gray#B
Green#B
GreenYellow#B
JungleGreen#B
Lavender#B
LimeGreen#B
Magenta#B
Mahogany#B
Maroon#B
Melon#B
MidnightBlue#B
Mulberry#B
NavyBlue#B
OliveGreen#B
Orange#B
OrangeRed#B
Orchid#B
Peach#B
Periwinkle#B
PineGreen#B
Plum#B
ProcessBlue#B
Purple#B
RawSienna#B
Red#B
RedOrange#B
RedViolet#B
Rhodamine#B
RoyalBlue#B
RoyalPurple#B
RubineRed#B
Salmon#B
SeaGreen#B
Sepia#B
SkyBlue#B
SpringGreen#B
Tan#B
TealBlue#B
Thistle#B
Turquoise#B
Violet#B
VioletRed#B
White#B
WildStrawberry#B
Yellow#B
YellowGreen#B
YellowOrange#B
