# colorblind package
# Matthew Bertucci 2024/12/23 for v1.1

#include:xcolor
#include:ifthen
#include:tikz
#include:tikzlibrarymath

#keyvals:\usepackage/colorblind#c
Tol
OkabeIto
pgf
no-tikz
keep-defaults
#endkeyvals

#ifOption:pgf
#include:pgfplots
#endif

#ifOption:Tol
T-Q-B0#B
T-Q-B1#B
T-Q-B2#B
T-Q-B3#B
T-Q-B4#B
T-Q-B5#B
T-Q-B6#B
T-Q-HC0#B
T-Q-HC1#B
T-Q-HC2#B
T-Q-HC3#B
T-Q-HC4#B
T-Q-V0#B
T-Q-V1#B
T-Q-V2#B
T-Q-V3#B
T-Q-V4#B
T-Q-V5#B
T-Q-V6#B
T-Q-M0#B
T-Q-M1#B
T-Q-M2#B
T-Q-M3#B
T-Q-M4#B
T-Q-M5#B
T-Q-M6#B
T-Q-M7#B
T-Q-M8#B
T-Q-M9#B
T-Q-MC0#B
T-Q-MC1#B
T-Q-MC2#B
T-Q-MC3#B
T-Q-MC4#B
T-Q-MC5#B
T-Q-MC6#B
T-Q-MC7#B
T-Q-PH0#B
T-Q-PH1#B
T-Q-PH2#B
T-Q-PH3#B
T-Q-PH4#B
T-Q-PH5#B
T-Q-DT0#B
T-Q-DT1#B
T-Q-DT2#B
T-Q-DT3#B
T-Q-DT4#B
T-Q-DT5#B
T-Q-L0#B
T-Q-L1#B
T-Q-L2#B
T-Q-L3#B
T-Q-L4#B
T-Q-L5#B
T-Q-L6#B
T-Q-L7#B
T-Q-L8#B
T-D-S0#B
T-D-S1#B
T-D-S2#B
T-D-S3#B
T-D-S4#B
T-D-S5#B
T-D-S6#B
T-D-S7#B
T-D-S8#B
T-D-S9#B
T-D-S10#B
T-D-S11#B
T-D-N0#B
T-D-N1#B
T-D-N2#B
T-D-N3#B
T-D-N4#B
T-D-N5#B
T-D-N6#B
T-D-N7#B
T-D-N8#B
T-D-N9#B
T-D-N10#B
T-D-N11#B
T-D-N12#B
T-D-N13#B
T-D-N14#B
T-D-N15#B
T-D-N16#B
T-D-N17#B
T-D-BR0#B
T-D-BR1#B
T-D-BR2#B
T-D-BR3#B
T-D-BR4#B
T-D-BR5#B
T-D-BR6#B
T-D-BR7#B
T-D-BR8#B
T-D-BR9#B
T-D-PG0#B
T-D-PG1#B
T-D-PG2#B
T-D-PG3#B
T-D-PG4#B
T-D-PG5#B
T-D-PG6#B
T-D-PG7#B
T-D-PG8#B
T-D-PG9#B
T-S-YOB0#B
T-S-YOB1#B
T-S-YOB2#B
T-S-YOB3#B
T-S-YOB4#B
T-S-YOB5#B
T-S-YOB6#B
T-S-YOB7#B
T-S-YOB8#B
T-S-YOB9#B
T-S-IR0#B
T-S-IR1#B
T-S-IR2#B
T-S-IR3#B
T-S-IR4#B
T-S-IR5#B
T-S-IR6#B
T-S-IR7#B
T-S-IR8#B
T-S-IR9#B
T-S-IR10#B
T-S-IR11#B
T-S-IR12#B
T-S-IR13#B
T-S-IR14#B
T-S-IR15#B
T-S-IR16#B
T-S-IR17#B
T-S-IR18#B
T-S-IR19#B
T-S-IR20#B
T-S-IR21#B
T-S-IR22#B
T-S-IR23#B
T-S-IN0#B
T-S-IN1#B
T-S-IN2#B
T-S-IN3#B
T-S-IN4#B
T-S-IN5#B
T-S-IN6#B
T-S-IN7#B
T-S-IN8#B
T-S-IN9#B
T-S-IN10#B
T-S-IN11#B
T-S-DR0#B
T-S-DR1#B
T-S-DR2#B
T-S-DR3#B
T-S-DR4#B
T-S-DR5#B
T-S-DR6#B
T-S-DR7#B
T-S-DR8#B
T-S-DR9#B
T-S-DR10#B
T-S-DR11#B
T-S-DR12#B
T-S-DR13#B
T-S-DR14#B
T-S-SR0#B
T-S-SR1#B
T-S-SR2#B
T-S-SR3#B
T-S-SR4#B
T-S-SR5#B
T-S-SR6#B
T-S-SR7#B
T-S-SR8#B
T-S-SR9#B
T-S-SR10#B
T-S-SR11#B
T-S-SR12#B
T-S-SR13#B
T-S-SR14#B
T-S-SR15#B
T-S-SR16#B
T-S-SR17#B
T-S-SR18#B
T-S-SR19#B
T-S-SR20#B
T-S-SR21#B
T-S-SR22#B
T-S-SR23#B
T-S-SR24#B
T-S-SR25#B
T-S-SR26#B
T-S-SR27#B
T-S-SR28#B
T-S-SR29#B
T-S-SR30#B
T-S-SR31#B
T-S-SR32#B
T-S-SR33#B
T-S-SR34#B
#endif

#ifOption:OkabeIto
OI0#B
OI1#B
OI2#B
OI3#B
OI4#B
OI5#B
OI6#B
OI7#B
#endif

\drawScheme{scheme}
\drawSchemeC{scheme}
\drawSchemeC[width]{scheme}

# not documented
\theColorNum#S
