# luciole-math package
# Matthew Bertucci 2025/07/09 for v0.50

#include:iftex
#include:unicode-math

#keyvals:\usepackage/luciole-math#c
no-logos
Numbers=#Uppercase,UppercaseOff,Lowercase,LowercaseOff,Lining,LiningOff,OldStyle,OldStyleOff,Proportional,ProportionalOff,Monospaced,MonospacedOff,SlashedZero,SlashedZeroOff,Arabic,ArabicOff,ResetAll
math-style=#ISO,TeX,french,upright
bold-style=#ISO,TeX,upright
nabla=#italic,upright
partial=#italic,upright
CharacterVariant={%<variants%>}
StylisticSet={%<sets%>}
Style={%<styles%>}
Scale=%<factor%>
#endkeyvals

\circledR
\circledS

# math mode commands defined by the package
\blacklozenge#m
\blacksquare#m
\Box#m
\centerdot#m
\circlearrowleft#m
\circlearrowright#m
\dashleftarrow#m
\dashrightarrow#m
\Diamond#m
\doteqdot#m
\doublecap#m
\doublecup#m
\gggtr#m
\gtreqqslantless#m
\gtreqslantless#m
\gvertneqq#m
\leadsto#m
\lesseqqslantgtr#m
\lesseqslantgtr#m
\lhd#m
\llless#m
\lozenge#m
\lvertneqq#m
\mbfdotlessi#*m
\mbfdotlessj#*m
\mbfimath#*m
\mbfjmath#*m
\mbfvarzero#*m
\mithbar#*m
\mupvarzero#*m
\ngeqq#m
\ngeqqslant#m
\ngeqslant#m
\nleqq#m
\nleqqslant#m
\nleqslant#m
\nparallelslant#m
\npreceq#m
\nshortmid#m
\nshortparallel#m
\nshortparallelslant#m
\nsubseteqq#m
\nsucceq#m
\nsupseteqq#m
\ntriangleleft#m
\ntriangleright#m
\overrightarc{arg}#m
\parallelslant#m
\restriction#m
\rhd#m
\shortmid#m
\shortparallel#m
\shortparallelslant#m
\smallfrown#m
\smallsmile#m
\square#m
\thickapprox#m
\thicksim#m
\unlhd#m
\unrhd#m
\varemptyset#m
\varpropto#m
\varsubsetneq#m
\varsubsetneqq#m
\varsupsetneq#m
\varsupsetneqq#m
\widearc{arg}#m

# supported math symbols from unicode-math
\bigstar#m
\bigwhitestar#m
\blacktriangle#m
\blacktriangledown#m
\cuberoot{arg}#m
\cuberootsign{arg}#*m
\doublebarwedge#m
\downdasharrow#m
\dualmap#m
\eqqslantgtr#m
\eqqslantless#m
\fint#m
\Finv#m
\fourthroot{arg}#m
\fourthrootsign{arg}#*m
\Game#m
\geqqslant#m
\intextender#*m
\Join#m
\leftcurvedarrow#m
\leftdasharrow#m
\leftwavearrow#m
\leqqslant#m
\lgblkcircle#m
\lgblksquare#m
\lgwhtsquare#m
\mdblkcircle#m
\mdblkdiamond#m
\mdblklozenge#m
\mdblksquare#m
\mdlgblkdiamond#m
\mdlgblklozenge#m
\mdlgwhtdiamond#m
\mdsmblkcircle#m
\mdsmblksquare#m
\mdsmwhtcircle#m
\mdsmwhtsquare#m
\mdwhtcircle#m
\mdwhtdiamond#m
\mdwhtlozenge#m
\mdwhtsquare#m
\mscre#*m
\mscrg#*m
\mscro#*m
\pitchfork#m
\precapprox#m
\preceqq#m
\precnapprox#m
\precneq#m
\precneqq#m
\Question#m
\rightcurvedarrow#m
\rightdasharrow#m
\rightwavearrow#m
\smallblacktriangleleft#m
\smallblacktriangleright#m
\smalltriangleleft#m
\smalltriangleright#m
\smblkdiamond#m
\smblklozenge#m
\smwhtlozenge#m
\sqint#m
\subseteqq#m
\subsetneqq#m
\succapprox#m
\succeqq#m
\succnapprox#m
\succneq#m
\succneqq#m
\supseteqq#m
\supsetneqq#m
\triangledown#m
\upand#m
\updasharrow#m
\vartriangle#m
\Vvert#m
\vysmblksquare#m
\vysmwhtsquare#m
\wedgebar#m
\Zbar#m

# not documented
\LuciMtoks#S
\LuciScale#S
